/*
 * puzzle.h
 *
 *
 * declarations for puzzle.c
 *
 * by Korbinian Strimmer and Arndt von Haeseler
 *
 */


/* load all necessary libraries */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>


/* all EXTERNal variables are local in puzzle.c */

#ifdef MAIN_MODULE
#define EXTERN
#else
#define EXTERN extern
#endif


/* global definitions */

#define TRUE 1
#define FALSE 0
#define boolean int

#define VERSION    "2.1"
#define DATE       "25 August 1995"


/* declarations of modules */

#include "qml.h"
#include "matrixut.h"
#include "treefuncs.h"
#include "quartet.h"
#include "random.h"


/*
 * puzzle.c
 */

/* pointer to files */
EXTERN FILE *treefp; /* treefile */

/* variables */
EXTERN int Info_optn;
EXTERN int Approx_optn;
EXTERN int pmode_optn;
EXTERN int Numtrial;   /* number of Puzzle trees */
EXTERN int Currtrial;  /* counter for Puzzle trees */
EXTERN int numleaves;  /* number of leaves remaining (fast Puzzle) */
EXTERN ivector trueID; /* leaf -> taxum on this leaf */
EXTERN ivector freeID;
EXTERN ivector freeleaves; /* list of free leaves (fast Puzzle): 1 = taxum available */
