/*
 * qml.h
 *
 *
 * declaration of all exported functions and variables of qml.c
 *
 * by Korbinian Strimmer and Arndt von Haeseler (1995)
 *
 */


#ifdef MAIN_MODULE        /* make external variables local in main module    */
#define EXTERN
#else
#define EXTERN extern
#endif


/*
 * includes
 */

#include <stdio.h>
#include "models.h"


/*
 * definitions
 */

typedef int       ivectpmty[TPMRADIX];
typedef double    dvectpmty[TPMRADIX];
typedef dvectpmty dmattpmty[TPMRADIX];


/*
 * exported variables
 */

EXTERN int Maxspc;        /* number of sequences in the infile               */
EXTERN int Maxsite;       /* lengths of the sequences                        */
EXTERN int Frequ_optn;    /* use data frequencies when computing ML          */
EXTERN int Converg;       /* flag for ML convergence:
                               Converg == 0:  no convergence
                               Converg == 0:  convergence
                               Converg == 0:  just before convergence        */
EXTERN int Numit;         /* number of ML iterations if there is convergence */
EXTERN dvectpmty Freqtpm; /* base frequencies used in the selected ML model  */


/*
 * exported functions
 */

void qmlstart();                                   /* start ML analysis      */
double quartet_lklhd(int a, int b, int c, int d);  /* compute ML             */
double quartet_alklhd(int a, int b, int c, int d); /* compute approximate ML */
void qmlfinish();                                  /* finish ML analysis     */
void fputid10(FILE *ofp, int t);                   /* print taxum (10 chars) */
int fputid(FILE *ofp, int t);                      /* print taxum            */
